#include <stdio.h>
#include <time.h>
#include <d3dx9.h>

#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")

#define MYWNDTITLE		"DX9_Sea"
#define MYWNDCLASS		"CLASS_DX9_Sea"
#define WIDTH			640 			// ʂ̉̃TCY
#define HEIGHT			480 			// ʂ̏c̃TCY
#define SEACOLOR		0x00004080
#define PI				(float)3.1415926535897932
#define RELEASE(p)		if (p){p->Release();p=NULL;}
#define DELETE2(p)		if (p){delete[] p;p=NULL;}
inline	DWORD FtoDW( FLOAT f ) { return *((DWORD*)&f); }

struct LVERTEX				// _tH[}bg̒`
{
	D3DXVECTOR3 v;			// W
	D3DXVECTOR3 n;			// @xNg	
	float		tu,tv;		// eNX`W
};
#define FVF_LVERTEX (D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1)

typedef struct{
	D3DXVECTOR3	v[225];			// _̍W
	D3DXVECTOR3	n[225];			// _̖@xNg
	float		tu[225],tv[225];// _̃eNX`W
	int 		f[196][4];		// eʂ̒_ԍ
}MODEL2,*LPMODEL2;

LPDIRECT3D9 			g_pD3D = NULL;
LPDIRECT3DDEVICE9		g_pD3DDev = NULL;
D3DPRESENT_PARAMETERS	g_d3dpp;
LPD3DXMESH				g_pMesh = NULL;	// bViCj
DWORD					g_nMat = 0L;	// }eA̐iCj
D3DMATERIAL9			*g_pMat = NULL;	// }eAf[^iCj
LPDIRECT3DTEXTURE9		*g_ppTex1; 		// eNX`iCj
LPDIRECT3DTEXTURE9		g_pTex2[32]; 	// eNX`igej
LPDIRECT3DTEXTURE9		g_pTex3;	 	// eNX`iCʁj
MODEL2		g_m2; 						// IuWFNg̏iCʁj
float		g_roll;				 		// IuWFNg̉]pxixj
int			g_flagY[225];				// yWړ̃tOi0:@1:j
float		g_eye_y = 0.31f;			// _YW

HRESULT InitD3D(HWND hWnd);
bool	InitGeometry();
void	SetCamera();
void	Set_Light();
void	Set_Material2();
void	Draw_Main();
void	Draw_Object();
void	Draw_Object2();
void	Get_Key();
void	Get_Mouse(HWND hWnd, POINT pt1, POINT pt2, float roll_g1, float eye_y1);
void	Create_Mesh();
void	Ave_Vtx();
void	Set_Normals();
HRESULT Load_Xfile(char *filename);
void	Cleanup();

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static POINT pt1;			// hbOJnʒu
	static float roll1,eye_y1;	// hbOJn̉]px
	
	switch(uMsg)
	{
	case WM_CREATE:
		if(FAILED(InitD3D(hWnd))){
			MessageBox(hWnd,"Ɏs܂",MYWNDTITLE,0);
			SendMessage(hWnd,WM_CLOSE,0,0);
			return 0;
		}
		if(FAILED( Load_Xfile("seafloor.x") )){
			MessageBox(hWnd,"t@C̓ǂݍ݂Ɏs܂",MYWNDTITLE,0);
			SendMessage(hWnd,WM_CLOSE,0,0);
			return 0;
		}
		srand((unsigned)time(NULL));
		SetTimer(hWnd,1,50,NULL);	//^C}[ݒB100 ̓^C}[Ԋu
		break;
		
	case WM_TIMER:
		Get_Key();					// L[͂̎擾
		Draw_Main();				// IuWFNg̕`
		break;
		
	case WM_KEYDOWN:
		switch ( wParam )
		{
			case VK_ESCAPE: 		// [ESC] L[ƏI
				SendMessage(hWnd, WM_CLOSE, 0, 0);
				break;
		}
		break;
		
	case WM_LBUTTONDOWN:
		SetCapture(hWnd);
		pt1.x = LOWORD(lParam);
		pt1.y = HIWORD(lParam);
		roll1  = g_roll;
		eye_y1 = g_eye_y;
		break;
		
	case WM_LBUTTONUP:
		ReleaseCapture();
		break;
		
	case WM_MOUSEMOVE:
		if(wParam & MK_LBUTTON){
			POINT pt2;
			pt2.x = LOWORD(lParam);
			pt2.y = HIWORD(lParam);
			Get_Mouse(hWnd, pt1, pt2, roll1, eye_y1);	// hbO̎擾
		}
		break;
		
	case WM_CLOSE:
		KillTimer(hWnd,1);			// ^C}[
		DestroyWindow(hWnd);
		Cleanup();					// Direct3D IuWFNg
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASSEX	wc;
	HWND		hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,IDI_WINLOGO);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(RegisterClassEx(&wc) == 0)
		return 0;

	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, WIDTH, HEIGHT,
				NULL,
				NULL,
				hInst,
				NULL);

	if(hWnd == NULL)
		return 0;

	MSG msg; 
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

// D3D9̏
HRESULT InitD3D(HWND hWnd)
{
	// Direct3D9 쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (!g_pD3D){
		return E_FAIL;
	}
	
	ZeroMemory( &g_d3dpp, sizeof(g_d3dpp) );
	g_d3dpp.Windowed = TRUE;
	g_d3dpp.SwapEffect = D3DSWAPEFFECT_FLIP;
	g_d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	g_d3dpp.EnableAutoDepthStencil = TRUE;
	g_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	
	// D3D9Device 쐬
	if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
									  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev ) ) ){
		if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, hWnd,
									  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev ) ) ){
			return E_FAIL;
		}
	}
	
	Create_Mesh();		// CʃbV̍쐬
	
	// geeNX`̓ǂݍ
	int i;
	char path[MAX_PATH];
	for(i=0;i<32;i++){
        sprintf(path, ".\\images\\Caust%02ld.tga", i);
		if(FAILED(D3DXCreateTextureFromFile(g_pD3DDev,path,&g_pTex2[i]))){
			g_pTex2[i] = NULL;
		}
	}
	// CʃeNX`̓ǂݍ
	D3DXCreateTextureFromFile(g_pD3DDev,".\\images\\sea.bmp",&g_pTex3);
	
	// 
	if(!InitGeometry()){
		return E_FAIL;
	}
	
	return S_OK;
}//InitD3D

// ݒ̏
bool InitGeometry()
{
	// JO̐ݒ
	g_pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	// Zobt@L
	g_pD3DDev->SetRenderState(D3DRS_ZENABLE, TRUE);
	// At@uh̐ݒ
	g_pD3DDev->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_SRCBLEND,  D3DBLEND_SRCALPHA);
	g_pD3DDev->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVDESTCOLOR);
	// eNX`W̍sϊL
	g_pD3DDev->SetTextureStageState(0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2);
	// eNX`̐ݒ
	g_pD3DDev->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	g_pD3DDev->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	
	// tHO̐ݒ
	FLOAT fFogStart =  0.3f;
	FLOAT fFogEnd	=  1.8f;
	g_pD3DDev->SetRenderState(D3DRS_FOGENABLE,		TRUE);
	g_pD3DDev->SetRenderState(D3DRS_FOGCOLOR,		SEACOLOR);
	g_pD3DDev->SetRenderState(D3DRS_FOGTABLEMODE,	D3DFOG_NONE);
	g_pD3DDev->SetRenderState(D3DRS_FOGVERTEXMODE,	D3DFOG_LINEAR);
	g_pD3DDev->SetRenderState(D3DRS_RANGEFOGENABLE, FALSE);
	g_pD3DDev->SetRenderState(D3DRS_FOGSTART,		FtoDW(fFogStart));
	g_pD3DDev->SetRenderState(D3DRS_FOGEND, 		FtoDW(fFogEnd));
	
	Set_Light();		// Cg̐ݒ
	
	// E̍LƃAXyNgƉs
	D3DXMATRIX matProj;
	D3DXMatrixPerspectiveFovLH(&matProj,D3DX_PI/4,(float)WIDTH/HEIGHT,0.01f,10.0f);
	g_pD3DDev->SetTransform(D3DTS_PROJECTION,&matProj);
	
	return 1;
}// InitGeometry

// J̐ݒ
void SetCamera()
{
	// J̈ʒu
	D3DXMATRIX matView;
	D3DXMatrixLookAtLH(&matView,&D3DXVECTOR3(0,g_eye_y,-0.45f),&D3DXVECTOR3(0,0,0),&D3DXVECTOR3(0,1,0));
	g_pD3DDev->SetTransform(D3DTS_VIEW,&matView);
	
}// SetCamera

// Ɩݒ
void Set_Light()
{
	D3DLIGHT9	light;
	
	ZeroMemory(&light, sizeof(D3DLIGHT9));
	light.Type       = D3DLIGHT_DIRECTIONAL;
	light.Diffuse.r = 1.0f;
	light.Diffuse.g = 1.0f;
	light.Diffuse.b = 1.0f;
	light.Specular.r = 1.0f;
	light.Specular.g = 1.0f;
	light.Specular.b = 1.0f;
	light.Direction = D3DXVECTOR3(0.577350f,-0.577350f,0.577350f);
	g_pD3DDev->SetLight(0, &light);
	g_pD3DDev->LightEnable(0, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_LIGHTING, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_AMBIENT, 0x00000000);
}// Set_Light

// }eA̐ݒ
void Set_Material2()
{
	D3DMATERIAL9 mtrl;
	
	ZeroMemory(&mtrl, sizeof(D3DMATERIAL9));
	mtrl.Diffuse.a  = 1.0f;
	mtrl.Diffuse.r  = mtrl.Ambient.r = 0.2f;
	mtrl.Diffuse.g  = mtrl.Ambient.g = 0.2f;
	mtrl.Diffuse.b  = mtrl.Ambient.b = 0.5f;
	mtrl.Specular.r = 1.0f;
	mtrl.Specular.g = 1.0f;
	mtrl.Specular.b = 1.0f;
	mtrl.Power      = 4.0f;
	// XyLFL
	g_pD3DDev->SetRenderState(D3DRS_SPECULARENABLE, TRUE);
	// }eAKp
	g_pD3DDev->SetMaterial(&mtrl);
}// Set_Material2

// `
void Draw_Main()
{	
	g_pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,SEACOLOR,1.0f,0);
	if( SUCCEEDED( g_pD3DDev->BeginScene() ) )
	{
		// Jʒuݒ
		SetCamera();
		
		// [hϊݒ
		D3DXMATRIX	matRY;
		D3DXMatrixRotationY(&matRY,g_roll/180*PI);
		g_pD3DDev->SetTransform(D3DTS_WORLD,&matRY);
		
		Draw_Object();	// C̕`
		
		g_pD3DDev->SetTexture(0, g_pTex3);
		Draw_Object2();	// Cʂ̕`
		
		g_pD3DDev->EndScene();
		g_pD3DDev->SetTexture(0, NULL);
	}
	g_pD3DDev->Present(NULL,NULL,NULL,NULL);
	
	// foCXƂ
	if(g_pD3DDev->TestCooperativeLevel() == D3DERR_DEVICENOTRESET){
		g_pD3DDev->Reset(&g_d3dpp);
		InitGeometry();
		Draw_Main();
	}
}// Draw_Main

// C̕`
void Draw_Object()
{
	DWORD		i;
	D3DXMATRIX	matS,matI;
	
	// eNX`W̃XP[O
	D3DXMatrixScaling(&matS, 5.5f, 5.5f, 0);
	g_pD3DDev->SetTransform(D3DTS_TEXTURE0, &matS);
	
	static int	idx = 0;
	g_pD3DDev->SetTexture(0, g_pTex2[idx ++]);
	if(idx >= 32){
		idx = 0;
	}
	for(i=0;i<g_nMat;i++)
	{
		g_pD3DDev->SetMaterial(&g_pMat[i]);
		g_pMesh->DrawSubset(i);
	}
	
	// eNX`W̃XP[O
	D3DXMatrixIdentity(&matI);
	g_pD3DDev->SetTransform(D3DTS_TEXTURE0, &matI);
}// Draw_Object

// Cʂ̕`
void Draw_Object2()
{
	int 		x,z;
	
	// yW𓮂
	for(z=0;z<14;z++){
		for(x=0;x<14;x++){
			if(((z % 2) && (x % 2)) || (!(z % 2) && !(x % 2))){
				if(g_m2.v[z*15+x].y >= 0.32f)
					g_flagY[z*15+x] = 1;
				else if(g_m2.v[z*15+x].y <= 0.3f)
					g_flagY[z*15+x] = 0;
				if(!g_flagY[z*15+x])
					g_m2.v[z*15+x].y += 0.001f;
				else
					g_m2.v[z*15+x].y -= 0.001f;
			}
		}
	}
	Ave_Vtx();
	for(x=0;x<15;x++){
		g_m2.v[14*15+x].y = g_m2.v[x].y;
	}
	for(z=0;z<15;z++){
		g_m2.v[z*15+14].y = g_m2.v[z*15].y;
	}
	g_m2.v[14*15].y = g_m2.v[14*15+14].y = g_m2.v[14].y = g_m2.v[0].y;
	
	// @xNg
	Set_Normals();
	
	// `
	Set_Material2();
	g_pD3DDev->SetFVF(FVF_LVERTEX);	// _tH[}bg̐ݒ
	g_pD3DDev->SetTextureStageState(0,D3DTSS_COLOROP,  D3DTOP_ADD);
	
	int 		i,j,v_idx;
	LVERTEX	lv[4];
	for(z=-1;z<=1;z++){
		for(x=-1;x<=1;x++){
			for(i=0;i<196;i++){
				for(j=0;j<4;j++){
					v_idx = g_m2.f[i][j];
					lv[j].v.x = g_m2.v[v_idx].x + 0.7f * x;
					lv[j].v.y = g_m2.v[v_idx].y - 0.2f;
					lv[j].v.z = g_m2.v[v_idx].z + 0.7f * z;
					lv[j].n  = g_m2.n [v_idx];
					lv[j].tu = g_m2.tu[v_idx];
					lv[j].tv = g_m2.tv[v_idx];
				}
				g_pD3DDev->DrawPrimitiveUP(D3DPT_TRIANGLEFAN,2,lv,sizeof(LVERTEX));
			}
		}
	}
	g_pD3DDev->SetTextureStageState(0,D3DTSS_COLOROP,  D3DTOP_MODULATE);
}// Draw_Object2

// L[
void Get_Key()
{
	if(GetAsyncKeyState(VK_LEFT) & 0x8000){ 		// []L[ꂽƂ
		g_roll -= 5;
		if(g_roll < 0)
			g_roll = 360;
	}
	else if(GetAsyncKeyState(VK_RIGHT) & 0x8000){	// []L[ꂽƂ
		g_roll += 5;
		if(g_roll >= 360)
			g_roll = 0;
	}
	if(GetAsyncKeyState(VK_UP) & 0x8000){ 			// []L[ꂽƂ
		g_eye_y += 0.01f;
		if(g_eye_y > 0.31f)
			g_eye_y = 0.31f;
	}
	else if(GetAsyncKeyState(VK_DOWN) & 0x8000){	// []L[ꂽƂ
		g_eye_y -= 0.01f;
		if(g_eye_y < 0.05f)
			g_eye_y = 0.05f;
	}
}// Get_Key

// }EX
void Get_Mouse(HWND hWnd, POINT pt1, POINT pt2, float roll1, float eye_y1)
{
	if(pt1.x != pt2.x || pt1.y != pt2.y){
		g_roll = roll1 - 0.5f * (pt2.x - pt1.x);
		if(g_roll < 0)
			g_roll = g_roll + 360;
		if(g_roll >= 360)
			g_roll = g_roll - 360;
		
		g_eye_y = eye_y1 - 0.002f * (pt2.y - pt1.y);
		if(g_eye_y < 0.05f)
			g_eye_y = 0.05f;
		if(g_eye_y > 0.31f)
			g_eye_y = 0.31f;
	}
}// Get_Mouse

// CʃbV̍쐬
void Create_Mesh()
{
	int		x,z;
	
	// yWړ̃tO
	for(z=0;z<14;z++){
		for(x=0;x<14;x++){
			g_flagY[z*15+x] = (int)(2.0f * rand() / (RAND_MAX + 1.0f));
		}
	}
	
	// _W
	for(z=0;z<15;z++){
		for(x=0;x<15;x++){
			g_m2.v[z*15+x].x = x*0.05f-0.35f;
			if(((z % 2) && (x % 2)) || (!(z % 2) && !(x % 2))){
				g_m2.v[z*15+x].y = 0.02f*(rand()/(float)RAND_MAX);
				g_m2.v[z*15+x].y = 0.015f*(rand()/(float)RAND_MAX);
			}
			g_m2.v[z*15+x].z = z*0.05f-0.35f;
		}
	}
	Ave_Vtx();
	
	for(x=0;x<225;x++){
		g_m2.v[x].y += 0.3f;
	}
	
	// eNX`W
	for(z=0;z<15;z++){
		for(x=0;x<15;x++){
			g_m2.tu[z*15+x] = (float)x/14;
			g_m2.tv[z*15+x] = (float)z/14;
		}
	}
	
	// eʂ̒_ԍ
	int ct = 0;
	for(z=0;z<14;z++){
		for(x=0;x<14;x++){
			g_m2.f[ct][0] = z*15+x;
			g_m2.f[ct][1] = (z+1)*15+x;
			g_m2.f[ct][2] = (z+1)*15+x+1;
			g_m2.f[ct][3] = z*15+x+1;
			ct ++;
		}
	}
}// Create_Mesh

// _yW͂P΂ɕϒlݒ肷
void Ave_Vtx()
{
	int		x,z;
	float	fy[4];
	
	for(z=0;z<14;z++){
		for(x=0;x<14;x++){
			if((!(z % 2) && (x % 2)) || ((z % 2) && !(x % 2))){
				if(x != 0)
					fy[0] = g_m2.v[z*15+(x-1)].y;
				else
					fy[0] = g_m2.v[z*15+14].y;
				if(x != 14)
					fy[1] = g_m2.v[z*15+(x+1)].y;
				else
					fy[1] = g_m2.v[z*15].y;
				if(z != 0)
					fy[2] = g_m2.v[(z-1)*15+x].y;
				else
					fy[2] = g_m2.v[14*15+x].y;
				if(z != 14)
					fy[3] = g_m2.v[(z+1)*15+x].y;
				else
					fy[3] = g_m2.v[x].y;
				g_m2.v[z*15+x].y = (fy[0]+fy[1]+fy[2]+fy[3])/4;
			}
		}
	}
}// Ave_Vtx

// Cʂ̖@xNgݒ肷
void Set_Normals()
{
	int x,z,x2,z2,x3,z3;
	D3DXVECTOR3 u,v,n[4];
	
	for(z=0;z<15;z++){
		for(x=0;x<15;x++){
			x2 = x - 1;
			if(x2 < 0)
				x2 = 13;
			x3 = x + 1;
			if(x3 > 14)
				x3 = 1;
			z2 = z - 1;
			if(z2 < 0)
				z2 = 13;
			z3 = z + 1;
			if(z3 > 14)
				z3 = 1;
			u = D3DXVECTOR3(    0, g_m2.v[z2*15+x].y-g_m2.v[z*15+x].y,-0.1f);
			v = D3DXVECTOR3(-0.1f, g_m2.v[z*15+x2].y-g_m2.v[z*15+x].y,    0);
			D3DXVec3Cross(&n[0], &u, &v);
			u = D3DXVECTOR3(-0.1f, g_m2.v[z*15+x2].y-g_m2.v[z*15+x].y,    0);
			v = D3DXVECTOR3(    0, g_m2.v[z3*15+x].y-g_m2.v[z*15+x].y, 0.1f);
			D3DXVec3Cross(&n[1], &u, &v);
			u = D3DXVECTOR3(    0, g_m2.v[z3*15+x].y-g_m2.v[z*15+x].y, 0.1f);
			v = D3DXVECTOR3( 0.1f, g_m2.v[z*15+x3].y-g_m2.v[z*15+x].y,    0);
			D3DXVec3Cross(&n[2], &u, &v);
			u = D3DXVECTOR3( 0.1f, g_m2.v[z*15+x3].y-g_m2.v[z*15+x].y,    0);
			v = D3DXVECTOR3(    0, g_m2.v[z2*15+x].y-g_m2.v[z*15+x].y,-0.1f);
			D3DXVec3Cross(&n[3], &u, &v);
			D3DXVec3Normalize(&g_m2.n[z*15+x], &(n[0]+n[1]+n[2]+n[3]));
		}
	}
}// Set_Normals

// X t@C̓ǂݍ
HRESULT Load_Xfile(char *fname)
{
	LPD3DXBUFFER	pD3DXBuf;
	LPD3DXMATERIAL	pD3DXMat;
	UINT i;
	
	// X t@C̓ǂݍ
	if(FAILED( D3DXLoadMeshFromX(fname,D3DXMESH_MANAGED,g_pD3DDev,NULL,&pD3DXBuf,NULL,&g_nMat,&g_pMesh)))
		return E_FAIL;
	
	// }eAEeNX`̎擾
	pD3DXMat = (D3DXMATERIAL*)pD3DXBuf->GetBufferPointer();
	g_pMat = new D3DMATERIAL9[g_nMat];
	g_ppTex1 = new LPDIRECT3DTEXTURE9[g_nMat];
	
	char path[MAX_PATH];
	for(i=0;i<g_nMat;i++){
		g_pMat[i] = pD3DXMat[i].MatD3D;
		g_pMat[i].Ambient = g_pMat[i].Diffuse;
		if(pD3DXMat[i].pTextureFilename){
			strcpy(path, ".\\images\\");
			strcat(path, pD3DXMat[i].pTextureFilename);
			if(FAILED( D3DXCreateTextureFromFile(g_pD3DDev, path, &g_ppTex1[i]) )){
				g_ppTex1[i] = NULL;
			}
		}
		else{
			g_ppTex1[i] = NULL;
		}
	}
	// obt@̉
	RELEASE(pD3DXBuf);
	
	return S_OK;
}// Load_Xfile

// IuWFNg̉
void Cleanup()
{
	UINT i;
	RELEASE(g_pMesh);
	DELETE2(g_pMat);
	// eNX`
	for(i=0;i<g_nMat;i++)
		RELEASE(g_ppTex1[i]);
	DELETE2(g_ppTex1);
	for(i=0;i<32;i++)
		RELEASE(g_pTex2[i]);
	RELEASE(g_pTex3);
	// D3D9 IuWFNg
	RELEASE(g_pD3DDev);
	RELEASE(g_pD3D);
}// Cleanup
