#include <stdio.h>
#include <d3dx9.h>

#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")

#define MYWNDTITLE		"DX9_SeaBottom"
#define MYWNDCLASS		"CLASS_DX9_SeaBottom"
#define WIDTH			640 			// ʂ̉̃TCY
#define HEIGHT			480 			// ʂ̏c̃TCY
#define SEACOLOR		0x00004080
#define PI				(float)3.1415926535897932
#define RELEASE(p)		if (p){p->Release();p=NULL;}
#define DELETE2(p)		if (p){delete[] p;p=NULL;}
inline	DWORD FtoDW( FLOAT f ) { return *((DWORD*)&f); }

LPDIRECT3D9 			g_pD3D = NULL;
LPDIRECT3DDEVICE9		g_pD3DDev = NULL;
D3DPRESENT_PARAMETERS	g_d3dpp;
LPD3DXMESH				g_pMesh = NULL; 	// bViCj
DWORD					g_nMat = 0L;		// }eA̐iCj
D3DMATERIAL9			*g_pMat = NULL; 	// }eAf[^iCj
LPDIRECT3DTEXTURE9		*g_ppTex1; 			// eNX`iCj
LPDIRECT3DTEXTURE9		g_pTex2[32]; 		// eNX`igej
float					g_roll = 0;

HRESULT InitD3D(HWND hWnd);
void	InitGeometry();
void	SetupMatrices();
void	Set_Light();
void	Draw_Main();
void	Get_Key();
HRESULT Load_Xfile(char *filename);
void	Cleanup();

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		if(FAILED( InitD3D(hWnd) )){
			MessageBox(hWnd,"D3D9̏Ɏs܂",MYWNDTITLE,0);
			SendMessage(hWnd,WM_CLOSE,0,0);
			return 0;
		}
		if(FAILED( Load_Xfile("seafloor.x") )){
			MessageBox(hWnd,"t@C̓ǂݍ݂Ɏs܂",MYWNDTITLE,0);
			SendMessage(hWnd,WM_CLOSE,0,0);
			return 0;
		}
		SetTimer(hWnd,1,50,NULL);	//^C}[ݒB100 ̓^C}[Ԋu
		break;
		
	case WM_TIMER:
		Get_Key();					// L[͂̎擾
		Draw_Main();				// IuWFNg̕`
		break;
		
	case WM_KEYDOWN:
		switch ( wParam )
		{
			case VK_ESCAPE: 		// [ESC] L[ƏI
				SendMessage(hWnd, WM_CLOSE, 0, 0);
				break;
		}
		break;
		
	case WM_CLOSE:
		KillTimer(hWnd,1);			// ^C}[
		DestroyWindow(hWnd);
		Cleanup();					// Direct3D IuWFNg
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASSEX	wc;
	HWND		hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,IDI_WINLOGO);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(RegisterClassEx(&wc) == 0)
		return 0;

	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, WIDTH, HEIGHT,
				NULL,
				NULL,
				hInst,
				NULL);

	if(hWnd == NULL)
		return 0;

	MSG msg; 
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

// D3D9̏
HRESULT InitD3D(HWND hWnd)
{
	// Direct3D9 쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (!g_pD3D){
		return E_FAIL;
	}
	
	ZeroMemory( &g_d3dpp, sizeof(g_d3dpp) );
	g_d3dpp.Windowed = TRUE;
	g_d3dpp.SwapEffect = D3DSWAPEFFECT_FLIP;
	g_d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	g_d3dpp.EnableAutoDepthStencil = TRUE;
	g_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	
	// D3D9Device 쐬
	if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
									  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev ) ) ){
		if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, hWnd,
									  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev ) ) ){
			return E_FAIL;
		}
	}
	
	// geeNX`̓ǂݍ
	char strName[80];
	for(int i=0;i<32;i++){
        sprintf(strName, ".\\images\\Caust%02ld.tga", i);
		if(FAILED( D3DXCreateTextureFromFile(g_pD3DDev, strName, &g_pTex2[i]) )){
			g_pTex2[i] = NULL;
		}
	}
	// ݒ̏
	InitGeometry();
	
	return S_OK;
}//InitD3D

// ݒ̏
void InitGeometry()
{
	// JO̐ݒ
	g_pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	// Zobt@L
	g_pD3DDev->SetRenderState(D3DRS_ZENABLE, TRUE);
	// eNX`̐ݒ
	g_pD3DDev->SetSamplerState     (0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	g_pD3DDev->SetSamplerState     (0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	// eNX`W̍sϊL
	g_pD3DDev->SetTextureStageState(0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2);
	
	// tHO̐ݒ
	FLOAT fFogStart =  0.5f;
	FLOAT fFogEnd	=  1.8f;
	g_pD3DDev->SetRenderState(D3DRS_FOGENABLE,		TRUE);
	g_pD3DDev->SetRenderState(D3DRS_FOGCOLOR,		SEACOLOR/2);
	g_pD3DDev->SetRenderState(D3DRS_FOGTABLEMODE,	D3DFOG_NONE);
	g_pD3DDev->SetRenderState(D3DRS_FOGVERTEXMODE,	D3DFOG_LINEAR);
	g_pD3DDev->SetRenderState(D3DRS_RANGEFOGENABLE, FALSE);
	g_pD3DDev->SetRenderState(D3DRS_FOGSTART,		FtoDW(fFogStart));
	g_pD3DDev->SetRenderState(D3DRS_FOGEND, 		FtoDW(fFogEnd));
	
	Set_Light();		// Cg̐ݒ
	SetupMatrices();	// ϊs̐ݒ
}// InitGeometry

// ϊs̐ݒ
void SetupMatrices()
{
	// J̈ʒu
	D3DXMATRIX matView;
	D3DXMatrixLookAtLH(&matView,&D3DXVECTOR3(0,0.5f,-0.8f),&D3DXVECTOR3(0,0,0),&D3DXVECTOR3(0,1,0));
	g_pD3DDev->SetTransform(D3DTS_VIEW,&matView);
	// E̍LƃAXyNgƋ
	D3DXMATRIX matProj;
	D3DXMatrixPerspectiveFovLH(&matProj,D3DX_PI/4,(float)WIDTH/HEIGHT,0.01f,10.0f);
	g_pD3DDev->SetTransform(D3DTS_PROJECTION,&matProj);
}// SetupMatrices

// Ɩݒ
void Set_Light()
{
	D3DXVECTOR3 vecDir;
	D3DLIGHT9	light;
	
	ZeroMemory( &light, sizeof(D3DLIGHT9) );
	light.Type		= D3DLIGHT_DIRECTIONAL;
	light.Diffuse.r = 1.0f;
	light.Diffuse.g = 1.0f;
	light.Diffuse.b = 1.0f;
	vecDir = D3DXVECTOR3(0.866025f,-0.5f,0.0f);
	D3DXVec3Normalize((D3DXVECTOR3*)&light.Direction, &vecDir);
	g_pD3DDev->SetLight(0, &light);
	g_pD3DDev->LightEnable(0, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_LIGHTING, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_AMBIENT, 0x004C4C4C);
}// Set_Light

// `
void Draw_Main()
{	
	g_pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,SEACOLOR,1.0f,0);
	if( SUCCEEDED( g_pD3DDev->BeginScene() ) )
	{
		DWORD		i;
		D3DXMATRIX	matR,matS;
		// [hϊsݒ
		D3DXMatrixRotationY(&matR, g_roll/180*PI);
		g_pD3DDev->SetTransform(D3DTS_WORLD, &matR);
		// eNX`W̃XP[O
		D3DXMatrixScaling(&matS, 5, 5, 0);
		g_pD3DDev->SetTransform(D3DTS_TEXTURE0, &matS);
		
		for(i=0;i<g_nMat;i++)
		{
			g_pD3DDev->SetMaterial(&g_pMat[i]);
			g_pD3DDev->SetTexture(0, g_ppTex1[i]);
			g_pMesh->DrawSubset(i);
		}
		
		// At@uhL
		g_pD3DDev->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
		g_pD3DDev->SetRenderState(D3DRS_SRCBLEND,  D3DBLEND_ONE);
		g_pD3DDev->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);
		
		static int	idx = 0;
		g_pD3DDev->SetTexture(0, g_pTex2[idx ++]);
		if(idx >= 32){
			idx = 0;
		}
		for(i=0;i<g_nMat;i++)
		{
			g_pD3DDev->SetMaterial(&g_pMat[i]);
			g_pMesh->DrawSubset(i);
		}
		g_pD3DDev->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
		
		g_pD3DDev->EndScene();
		
		g_pD3DDev->SetTexture(0, NULL);
	}
	g_pD3DDev->Present(NULL,NULL,NULL,NULL);
	
	// foCXƂ
	if(g_pD3DDev->TestCooperativeLevel() == D3DERR_DEVICENOTRESET){
		g_pD3DDev->Reset(&g_d3dpp);
		InitGeometry();
		Draw_Main();
	}
}// Draw_Main

// L[
void Get_Key()
{
	if(GetAsyncKeyState(VK_LEFT) & 0x8000){ 		// []L[ꂽƂ
		g_roll -= 5;
		if(g_roll == 0)
			g_roll = 360;
	}
	else if(GetAsyncKeyState(VK_RIGHT) & 0x8000){	// []L[ꂽƂ
		g_roll += 5;
		if(g_roll == 360)
			g_roll = 0;
	}
}// Get_Key

// X t@C̓ǂݍ
HRESULT Load_Xfile(char *fname)
{
	LPD3DXBUFFER	pD3DXBuf;
	LPD3DXMATERIAL	pD3DXMat;
	UINT i;
	
	// X t@C̓ǂݍ
	if(FAILED( D3DXLoadMeshFromX(fname,D3DXMESH_MANAGED,g_pD3DDev,NULL,&pD3DXBuf,NULL,&g_nMat,&g_pMesh)))
		return E_FAIL;
	
	// }eAEeNX`̎擾
	pD3DXMat = (D3DXMATERIAL*)pD3DXBuf->GetBufferPointer();
	g_pMat = new D3DMATERIAL9[g_nMat];
	g_ppTex1 = new LPDIRECT3DTEXTURE9[g_nMat];
	
	char path[MAX_PATH];
	for(i=0;i<g_nMat;i++){
		g_pMat[i] = pD3DXMat[i].MatD3D;
		g_pMat[i].Ambient = g_pMat[i].Diffuse;
		if(pD3DXMat[i].pTextureFilename){
			_snprintf(path,sizeof(path),".\\images\\%s",pD3DXMat[i].pTextureFilename);
			if(FAILED( D3DXCreateTextureFromFile(g_pD3DDev, path, &g_ppTex1[i]) )){
				g_ppTex1[i] = NULL;
			}
		}
		else{
			g_ppTex1[i] = NULL;
		}
	}
	// obt@̉
	RELEASE(pD3DXBuf);
	
	return S_OK;
}// Load_Xfile

// IuWFNg̉
void Cleanup()
{
	UINT i;
	RELEASE(g_pMesh);
	DELETE2(g_pMat);
	for(i=0;i<g_nMat;i++)
		RELEASE(g_ppTex1[i]);
	DELETE2(g_ppTex1);
	for(i=0;i<32;i++)
		RELEASE(g_pTex2[i]);
	RELEASE(g_pD3DDev);
	RELEASE(g_pD3D);
}// Cleanup
